shader_type canvas_item;

uniform float scale = 270.0;
uniform float speed = 10.0;

uniform float outline_width = 0.07;
uniform vec4 outline_color = vec4(0.0, 0.0, 0.0, 1.0);

void fragment() {
	
	vec4 col = texture(TEXTURE, UV);
	vec2 ps = TEXTURE_PIXEL_SIZE;
	float a;
	float maxa = col.a;
	float mina = col.a;

	a = texture(TEXTURE, UV + vec2(0.0, -outline_width) * ps).a;
	maxa = max(a, maxa);
	mina = min(a, mina);

	a = texture(TEXTURE, UV + vec2(0.0, outline_width) * ps).a;
	maxa = max(a, maxa);
	mina = min(a, mina);

	a = texture(TEXTURE, UV + vec2(-outline_width, 0.0) * ps).a;
	maxa = max(a, maxa);
	mina = min(a, mina);

	a = texture(TEXTURE, UV + vec2(outline_width, 0.0) * ps).a;
	maxa = max(a, maxa);
	mina = min(a, mina);
	
	float c = sin(UV.x * scale + UV.y * scale + TIME*speed);
	COLOR = mix(col, outline_color*c, (maxa - mina));
}